#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfs(vector<vector<ll>> &graph, vector<int> &used, ll curr, ll h) {
  used[curr] = 1;
  if (h == 0)
    return;
  for (ll i = 0; i < graph[curr].size(); i++) {
    if (used[graph[curr][i]] == 0) {
      dfs(graph, used, graph[curr][i], h - 1);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  cin >> n >> m >> k;
  vector<vector<ll>> graph(n);
  vector<pair<ll, ll>> securities(k);
  for (ll i = 0; i < m; i++) {
    ll a, b;
    cin >> a >> b;
    graph[a - 1].push_back(b - 1);
    graph[b - 1].push_back(a - 1);
  }
  for (ll i = 0; i < k; i++) {
    cin >> securities[i].first >> securities[i].second;
    securities[i].first--;
  }
  vector<int> used(n);
  for (ll i = 0; i < k; i++) {
    dfs(graph, used, securities[i].first, securities[i].second);
  }
  ll s = count(used.begin(), used.end(), 1);
  if (s == 0) {
    cout << "";
    return 0;
  }
  cout << s << "\n";
  for (ll i = 0; i < n; i++) {
    if (used[i])
      cout << i + 1;
    if (i < n - 1)
      cout << " ";
    else
      cout << "\n";
  }
  return 0;
}
